/*
vdec.c oggvorsisfR[h
libogg,libvorbis̒쌠Xiphophorusɂ܂B
*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <vorbis/codec.h>
#include <vorbis/vorbisfile.h>
#include <io.h>
#include <fcntl.h>
#include <windows.h>

//CũN
#pragma comment(lib , "libogg_static_vc2013xp")
#pragma comment(lib , "libvorbis_static_vc2013xp")
#pragma comment(lib , "libvorbisfile_static_vc2013xp")

// kvst@C̖OɁAo͂oggt@C̖O߂B
static void GetWavFileName(char *pBufWavFileName, char *pBufOggFileName ) {
	strcpy(pBufWavFileName, pBufOggFileName);

	// .oggƕύXB
	strcpy(pBufWavFileName+strlen(pBufWavFileName)-4, ".wav");
}


/* WAVEt@C̃wb_ */
typedef struct{
	char ckidRIFF[4];
	int ckSizeRIFF;
	char fccType[4];
	char ckidFmt[4];
	int ckSizeFmt;
	WAVEFORMATEX WaveFmt;
	char ckidData[4];
	int ckSizeData;
} WAVEFILEHEADER;


//##############################################################################
// long LoadOggVorbis(char *file_name, int word, char **ogg)
//
// Tv
//     t@COggVorbis`̃f[^ǂݍ݁AWAVE`ŃfR[
//   hB
//     f[^svɂȂ ReleaseOggVorbis pė̈JȂĂ͂Ȃ
//   ȂB
//
// 
//     *file_name : ǂݍރt@C
//     word       : ʎqoCg
//                  1  2 w肷B
//     **ogg      : f[^i[char^̃|C^ւ̃|C^
//
// ߂l
//     0 菬 : G[
//     0 傫 : TCY
//##############################################################################
int OggToWav(char *szOggFileName ) {

	char *ogg = NULL;

	OggVorbis_File vf;
	vorbis_info *vi;
	int eof=0;
	int current_section;
	FILE *fp;
	WAVEFILEHEADER wh;
	long whsize;
	long size = 0;
	long data_size;
	int ret;
	int word = 2;

	char szWavFileName[256] = "";
	GetWavFileName( szWavFileName, szOggFileName );
	/* t@CJ */
	FILE *pwav = fopen(szWavFileName, "wb");

	/* t@CJ */
	fp = fopen(szOggFileName, "rb");
	if(fp == NULL){
		fprintf(stderr, "Open Error : %s", szOggFileName);
		return -1;
	}

	/* OggVorbis */
	if(ov_open(fp, &vf, NULL, 0) < 0) {
		fprintf(stderr,"Input does not appear to be an Ogg bitstream.\n");
		fclose(fp);
		return -1;
	}

	/* ڍ׎ */
	vi = ov_info(&vf,-1);
	if(vi == NULL){
		fprintf(stderr, "Get Info Error\n");
		return -1;
	}

	/* wb_TCY̎ */
	/* sizeof(wh) ƑSẴõTCY̍v傫ȂĂ܂ */
	whsize = sizeof(wh.ckidRIFF) + sizeof(wh.ckSizeRIFF) + sizeof(wh.fccType) +
		sizeof(wh.ckidFmt)  + sizeof(wh.ckSizeFmt)  + sizeof(wh.WaveFmt) +
		sizeof(wh.ckidData) + sizeof(wh.ckSizeData);

	/* fR[h̃f[^TCY߁Am */
	data_size = (long)ceil(vi->channels * vi->rate * ov_time_total(&vf,-1) * word );

	ogg = (char *)malloc(data_size + whsize);
	if(ogg == NULL){
		free(ogg);
		ov_clear(&vf);
		fclose(fp);
		fprintf(stderr, "malloc Error\n");
		return -1;
	}


	/* fR[h */
	/* Ńobt@SĂɃfR[hƂ͌Ȃ */
	/* ɂ 256`4096Byte fR[h悤  */

	while(!eof){
		ret = ov_read(&vf, ogg + size + whsize, data_size - size, 0, word, 1, &current_section);
		if (ret == 0) {
			eof=1;
		} else if (ret < 0) {
			free(ogg);
			ov_clear(&vf);
			fclose(fp);
			fprintf(stderr, "Decode Error\n");
			return -1;
		} else {
			size += ret;
		}
	}


	/* wb_̏ */
	memcpy(wh.ckidRIFF, "RIFF", 4);
	wh.ckSizeRIFF = whsize + size - 8;
	memcpy(wh.fccType, "WAVE", 4);
	memcpy(wh.ckidFmt, "fmt ", 4);
	wh.ckSizeFmt = sizeof(WAVEFORMATEX);

	wh.WaveFmt.cbSize          = sizeof(WAVEFORMATEX);
	wh.WaveFmt.wFormatTag      = WAVE_FORMAT_PCM;
	wh.WaveFmt.nChannels       = (WORD)(vi->channels);
	wh.WaveFmt.nSamplesPerSec  = vi->rate;
	wh.WaveFmt.nAvgBytesPerSec = vi->rate * vi->channels * word;
	wh.WaveFmt.nBlockAlign     = (WORD)(vi->channels * word);
	wh.WaveFmt.wBitsPerSample  = (WORD)(word * 8);

	memcpy(wh.ckidData, "data", 4);
	wh.ckSizeData = size;


	/* ւ̃wb_̏ */
	int s = 0;
	memcpy(ogg, &wh.ckidRIFF, sizeof(wh.ckidRIFF));
	s += sizeof(wh.ckidRIFF);
	memcpy(ogg + s, &wh.ckSizeRIFF, sizeof(wh.ckSizeRIFF));
	s += sizeof(wh.ckSizeRIFF);
	memcpy(ogg + s, &wh.fccType, sizeof(wh.fccType));
	s += sizeof(wh.fccType);
	memcpy(ogg + s, &wh.ckidFmt, sizeof(wh.ckidFmt));
	s += sizeof(wh.ckidFmt);
	memcpy(ogg + s, &wh.ckSizeFmt, sizeof(wh.ckSizeFmt));
	s += sizeof(wh.ckSizeFmt);
	memcpy(ogg + s, &wh.WaveFmt, sizeof(wh.WaveFmt));
	s += sizeof(wh.WaveFmt);
	memcpy(ogg + s, &wh.ckidData, sizeof(wh.ckidData));
	s += sizeof(wh.ckidData);
	memcpy(ogg + s, &wh.ckSizeData, sizeof(wh.ckSizeData));

	/* cleanup */
	ov_clear(&vf);

	if ( pwav ) {
		fwrite( ogg, data_size + whsize, 1, pwav );
		fclose(pwav);
	}

	free(ogg);

	return 0;
}


